#!/usr/bin/env node
(function(){
  var optimist, argv, fs, sys, jinjs, parser, transform_files, file, data, _i, _ref, _len;
  optimist = require("optimist").usage("Transform a JinJS formatted file or stdin to a javascript function\n or execute it directly with a given context.\nUsage: $0 [options] file\n       $0 [options]").boolean("help").alias("help", "h").describe("help", "Show this help");
  argv = optimist.argv;
  fs = require("fs");
  sys = require("sys");
  jinjs = require("./jinjs_prev");
  if (argv.help) {
    console.log(optimist.help());
    process.exit(0);
  }
  parser = jinjs.Parser();
  transform_files = true;
  function compile(string){
    var parsed, compiled_function;
    parsed = parser.parse(string);
    compiled_function = parsed.compile();
    return "(function (ctx, env) {var _blocs = {};env = env || _default_env;var _res = '';" + compiled_function + "return _res; })";
  }
  if (argv._.length > 0) {
    for (_i = 0, _len = (_ref = argv._).length; _i < _len; ++_i) {
      file = _ref[_i];
      fs.readFile(file, 'utf-8', function(err, data){
        if (err) {
          console.warn(err.message);
          return;
        }
        return sys.print(compile(data));
      });
    }
  } else {
    process.stdin.resume();
    process.stdin.setEncoding("utf-8");
    data = "";
    process.stdin.on("data", function(chunk){
      return data += chunk;
    });
    process.stdin.on("end", function(){
      return sys.print(compile(data));
    });
  }
}).call(this);
